/*: TAVLDALL.C	TAVL Tree library    Version 3.01   6-feb-93
 *: Prototype:	void tavl_delete_all(TAVL_treeptr)
 *: Purpose:	Remove all data nodes, freeing dynamic memory; leave tree empty
 *
 *
 *  Released to PUBLIC DOMAIN
 *
 *			    Bert C. Hughes
 *			    200 N.Saratoga
 *			    St.Paul, MN 55104
 *			    Compuserve 71211,577
 */

#include "tavlpriv.h"

void tavl_delete_all(TAVL_treeptr tree)
{
    register TAVL_nodeptr q;
    register TAVL_nodeptr p = tavl_succ(tavl_reset(tree));

    while (p) {
	p = tavl_succ(q = p);
	(*tree->free_item)(q->dataptr);
	(*tree->dealloc)(q);
    }
    /* fix up the head node */
    tree->head.Lbit = THREAD;
    tree->head.Lptr = &tree->head;
}
